package RebuildAt1stView;

use strict;
use base qw( MT::App );

use MT;
use MT::Template;
use MT::WeblogPublisher;

@RebuildAt1stView::ISA = qw(MT::App);

sub init {
	my $app = shift;
	$app->SUPER::init_request(@_);
	$app->add_methods( main => \&view );
	$app->{default_mode} = 'main';
	$app->{requires_login} = 0;
	$app;
}

my $mt = MT->new(Config => '../../mt-config.cgi');

sub view {
    my $app = shift;
    my $blog_id;
    my $uri = $app->param('uri') || $ENV{"REDIRECT_URL"}; #$app->path_info;
    my $cfg = $app->config;
    require MT::Blog;
    my $blog = MT::Blog->load(undef)
        or return $app->error($app->translate("Loading blog failed"));
    my $org_uri = $uri;
    my $idx = $cfg->IndexBasename || 'index';
    my $ext = $blog->file_extension || '';
    $idx .= '.' . $ext if $ext ne '';
    my @urls = ( $uri );
    if ($uri =~ /\/$/) {
        $uri .= $idx;
    }
    require MT::FileInfo;
    my $fi = MT::FileInfo->load({
        url => $uri
    }); 
    if ($fi) {
        unless ($blog_id) {
           $blog_id = $fi->blog_id;
        }
        my $pub = MT::WeblogPublisher->new;
        my $res = $pub->rebuild_from_fileinfo($fi);
        if ($res) {
            my $fp = $fi->file_path;
            if (-e $fp) {
                $app->redirect($org_uri);
            }
#             open(FH, $fp);
#             my $html;
#             while(<FH>){
#                 $html .= $_;
#             }
#             close(FH);
#             return $html;
        }
    }
    unless ($blog_id) {
       $blog_id = $blog->id;
    }
    if (my $tmpl = MT::Template->load({ blog_id => $blog_id,
        type => 'dynamic_error' })) {
        my $ctx = $tmpl->context;
        $ctx->stash('blog', $blog);
        $ctx->stash('blog_id', $blog_id);
        return $tmpl->output();
    }
    return $app->error("File not found");
}

1;
